# COUNT\_ACCOUNTS

## Overview

*This method allows you to aggregate and count accounts with a robust filter object. There are many types of filters you can apply and you can find information regarding those in the* [*Filters*](https://carpool.gitbook.io/carpool/api-reference/filters) *section of the docs. The endpoint example here shows off one of the many filters.*

{% openapi src="<https://2513171703-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FE1gzfwcjB542lI2VR9XI%2Fuploads%2FuQVV2G2iqk0uWmgRzZGu%2FCarpool_dev-COUNT_ACCOUNTS-0.1-resolved.json?alt=media&token=3b0ea532-3e6c-448d-ac05-35b942f93b13>" path="/query/solana" method="post" %}
[Carpool\_dev-COUNT\_ACCOUNTS-0.1-resolved.json](https://2513171703-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FE1gzfwcjB542lI2VR9XI%2Fuploads%2FuQVV2G2iqk0uWmgRzZGu%2FCarpool_dev-COUNT_ACCOUNTS-0.1-resolved.json?alt=media\&token=3b0ea532-3e6c-448d-ac05-35b942f93b13)
{% endopenapi %}

## Filters

As mentioned above, the api definition here illustrates one of Carpool's many filter types. All queries that accept a filter object in the POST body can make use of **any** of the potential filters. Please see the Account Filters section of the documentation to better understand how they are implemented for account related queries.

{% content-ref url="../filters/account-filters" %}
[account-filters](https://carpool.gitbook.io/carpool/api-reference/filters/account-filters)
{% endcontent-ref %}

## Example - Basic

**Program** - *Candy Machine*

**Description** *- Count all CandyMachine accounts where the value at data.creators.percentageShare is equal to 100*

#### Javascript

```javascript
var myHeaders = new Headers();
myHeaders.append("x-api-key", "<API_KEY>");
myHeaders.append("Content-Type", "application/json");

var raw = JSON.stringify({
  "type": "COUNT_ACCOUNTS",
  "query": {
    "programId": "CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR",
    "accountName": "CandyMachine",
    "filter": {
      "type": "ACCOUNT_DATA_NUMERIC",
      "path": "data.creators.percentageShare",
      "range": {
        "eq": 100
      }
    }
  }
});

var requestOptions = {
  method: 'POST',
  headers: myHeaders,
  body: raw,
  redirect: 'follow'
};

fetch("https://mainnet.carpool.dev/query/solana", requestOptions)
  .then(response => response.text())
  .then(result => console.log(result))
  .catch(error => console.log('error', error));
```

#### cURL

```
curl --location 'https://mainnet.carpool.dev/query/solana' \
--header 'x-api-key: <API_KEY>' \
--header 'Content-Type: application/json' \
--data '{
    "type": "COUNT_ACCOUNTS",
    "query": {
        "programId": "CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR",
        "accountName": "CandyMachine",
        "filter": {
            "type": "ACCOUNT_DATA_NUMERIC",
            "path": "data.creators.percentageShare",
            "range": {
                "eq": 100
            }
        }
    }
}'
```

## Example - Advanced

**Program** - *Candy Machine*

**Description** *- Count all CandyMachine accounts where the value at data.creators.percentageShare is equal to 100. Only include accounts within the specified time range for the final count.*

#### Javascript

```javascript
var myHeaders = new Headers();
myHeaders.append("x-api-key", "<API_KEY>");
myHeaders.append("Content-Type", "application/json");

var raw = JSON.stringify({
  "type": "COUNT_ACCOUNTS",
  "query": {
    "programId": "CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR",
    "accountName": "CandyMachine",
    "filter": {
      "type": "ACCOUNT_DATA_NUMERIC",
      "path": "data.creators.percentageShare",
      "range": {
        "eq": 100
      },
      "timeRange": {
        "before": "2023-07-12T22:53:09+0000",
        "after": "2023-07-11T22:53:09+0000"
      }
    }
  }
});

var requestOptions = {
  method: 'POST',
  headers: myHeaders,
  body: raw,
  redirect: 'follow'
};

fetch("https://mainnet.carpool.dev/query/solana", requestOptions)
  .then(response => response.text())
  .then(result => console.log(result))
  .catch(error => console.log('error', error));
```

#### cURL

```
curl --location 'https://mainnet.carpool.dev/query/solana' \
--header 'x-api-key: <API_KEY>' \
--header 'Content-Type: application/json' \
--data '{
    "type": "COUNT_ACCOUNTS",
    "query": {
        "programId": "CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR",
        "accountName": "CandyMachine",
        "filter": {
            "type": "ACCOUNT_DATA_NUMERIC",
            "path": "data.creators.percentageShare",
            "range": {
                "eq": 100
            },
            "timeRange": {
                "before": "2023-07-12T22:53:09+0000",
                "after": "2023-07-11T22:53:09+0000"
            }
        }
    }
}'
```
